<%@ page import="sms.*" %>
<%!
	/**
	* This page is responsible for setting up the environment
	* for all other pages. It is included in all which requires that
	* a user is logged in.
	*
	* Logged in means that the user must have SmsAccount in
	* the session, if the user don't have it then we send him
	* to the login-page.
	*/
	
	/**
	* Simple function to retrive the SmsAccount from session
	*
	* @param hs The session
	*
	* @return The SmsAccount or null
	*/
	public SmsAccount getAccount(HttpSession hs)
	{
		return (SmsAccount)hs.getAttribute("ACCOUNT");
	}
	
	/** Define the date-format that we will use for both parsing
	 * and date presentation
	 */
	public static final String DATE_FORMAT = "yyyy-MM-dd HH:mm:ss";
	
%> 

<%
	// Lets do a login-check
	SmsAccount account = getAccount(session);
	
	if(account == null)
	{
		// User is not logged in, send them to login page.
		
		// Render a simple java-scipt redirect page to do this.
		// We use a script instead of using response.sendRedirect
		// because we wan't to escape the frameset.
		
		//
		// Lets construct the URL to redirect to, first the protocol and hostname
		// [protocol]://[hostname]
		//
		String url = request.getScheme() + "://" + request.getServerName();
		
		// Then the port if its not standard port
		if(request.getServerPort() != 80)
			url = url + ":" + request.getServerPort();
		
		// And then the context (if not root)		
		if(!"".equals(request.getContextPath()))
			url = url + request.getContextPath();
		
		// And finally the page we wan't to redirect to ..
		url = url + "/login.jsp";
		
		//
		// And we write our little page to client.
		out.write("<html>");
			out.write("<head>");
				out.write("<script>");
    				out.write("	parent.location.href = '" + url + "';");
				out.write("</script>");
			out.write("</head>");
			out.write("<body>");
			out.write("</body>");
		out.write("</html>");
		
		// We have a return here since this page is included in other pages,
		// and if user is not logged in we can't let the orginal page continue.		
		return;
	}
		
%>
	