from base.Logger import *
import re

class Sms:

    """
        $Id: Sms.py,v 1.1.1.1 2003/04/10 14:38:57 maro Exp $

        Represents an SMS message
        
        @author maro
    """

    STATUS_REPORT_YES = "true"
    STATUS_REPORT_NO  = "false"

    m_originator = None
    m_recipient  = None
    m_text = None
    m_status_reporting = None
    m_valid_to = ""
    m_delivered = ""
    m_log = None

    def __init__(self, recipient="", text=""):
        self.m_log = Logger()
        self.m_recipient = recipient
        self.setText(text)
        self.m_status_reporting = self.STATUS_REPORT_NO

    def setRecipient(self, recipient):
        self.m_recipient = recipient

    def setText(self, text):
        """Sets the text of the SMS message, using Unicode"""
        self.m_text = unicode(text, "latin-1")

    def setUnicodeText(self, text):
        """Since we are receiving from a Java socket we get Unicode text,
            this method is called by the Request class when building the request"""
        self.m_text = text

    def setOriginator(self, originator):
        self.m_originator = originator

    def setValidTo(self, validTo):
        self.m_valid_to = validTo

    def setDelivered(self, delivered):
        self.m_delivered = delivered

    def getRecipient(self):
        return self.m_recipient

    def getOriginator(self):
        return self.m_originator

    def getText(self):
        """Returns the text of the SMS message, encodes the Unicode text"""
        return self.m_text.encode("latin-1")

    def getStatusReporting(self):
        return self.m_status_reporting

    def getValidTo(self):
        return self.m_valid_to

    def getDelivered(self):
        return self.m_delivered


    def isValidMobile(self):
        """Checks to see if the mobilephone number is formatted correct"""
        mob = self.m_recipient
        if ( mob != "" ):
            two = mob[0:2]
            first = mob[0]
            if ( first != "+" and two != "00" ):
                return None
            else:
                rest = mob[1:]
                if ( re.search("\D", rest) is None ):
                    return 1
                else:
                    return None
        else:
            return None

    def isValidText(self):
        """Checks the text of the message"""
        txt = self.m_text
        length = len(txt)
        if ( txt != "" ):
            if ( len(txt) > 160 ):
                return None
            else:
                return 1
        else:
            return None
