<?php

    //
    // Copyright (c) 2002-2003 Zyneo HB. (http://www.zyneo.com)
    // See LICENSE distributed with this package for more information.
    //

    include_once(_DOCROOT . "/base/Base.php");
    
    /**
     * $Id: ClientSocket.php,v 1.1.1.1 2003/03/27 10:27:42 maro Exp $
     *
     * Provides a simple Socket object sending messages to sockets and read 
     * the response.
     * @package adapter.socket
     * @author Magnus Rosenquist, Zyneo
     */
    class ClientSocket
        extends Base
    {
        /** Host to connect to */
        var $__host = "";
        /** Port to connect to */
        var $__port = "";
        
        /**
         * Creates a new ClientSocket for use with specified host and port
         * @param string $host
         * @param int $port
         */
        function ClientSocket($host, $port)
        {
            $this->registerClass(get_class($this));
            $this->__host = $host;
            $this->__port = $port;  
        }

        /** 
         * Sends a message to the desired host/port and reads the 
         * response from the socket and returns this to the calling app.
         * @param string $message the message to send.
         * @return string response from socket.
         */        
        function send($message)
        {
            $this->registerMethod("send");
            $msg = trim($message);
            $this->logDebug("Connecting to: [".$this->__host .":" .$this->__port."]");
            $socket = socket_create(AF_INET, SOCK_STREAM, 0) 
                or die ("Could not create socket!\n\n");
            $result = socket_connect($socket, $this->__host, $this->__port)
                or die ("Could not connect!\n\n");                
            $this->logDebug("Connected...");
            socket_write($socket, $msg, strlen($msg));
            $this->logDebug("Message sent.");
            $response = socket_read($socket, 1024);
            socket_close($socket);
            $this->logDebug("Socket closed.");
            return $response;
        }
        
    }
?>
